// Auto-generated. Do not edit!

// (in-package hri_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class Expression {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.expression = null;
      this.valence = null;
      this.arousal = null;
    }
    else {
      if (initObj.hasOwnProperty('expression')) {
        this.expression = initObj.expression
      }
      else {
        this.expression = 0;
      }
      if (initObj.hasOwnProperty('valence')) {
        this.valence = initObj.valence
      }
      else {
        this.valence = 0.0;
      }
      if (initObj.hasOwnProperty('arousal')) {
        this.arousal = initObj.arousal
      }
      else {
        this.arousal = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Expression
    // Serialize message field [expression]
    bufferOffset = _serializer.uint8(obj.expression, buffer, bufferOffset);
    // Serialize message field [valence]
    bufferOffset = _serializer.float32(obj.valence, buffer, bufferOffset);
    // Serialize message field [arousal]
    bufferOffset = _serializer.float32(obj.arousal, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Expression
    let len;
    let data = new Expression(null);
    // Deserialize message field [expression]
    data.expression = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [valence]
    data.valence = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [arousal]
    data.arousal = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 9;
  }

  static datatype() {
    // Returns string type for a message object
    return 'hri_msgs/Expression';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'a4270f65fbf4fe442fdcf2aea90563f7';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Represents a human facial expression, either in a categorical way, or
    # using the valence/arousal model of emotions
    
    
    # Eckman model of emotions
    uint8 NEUTRAL=0
    uint8 HAPPY=1
    uint8 SAD=2
    uint8 ANGER=3
    uint8 SURPRISE=4
    uint8 DISGUST=5
    uint8 FEAR=6
    
    uint8 expression
    
    # Valence/Arousal model of emotions
    float32 valence # from -1.0 to +1.0
    float32 arousal # from -1.0 to +1.0
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Expression(null);
    if (msg.expression !== undefined) {
      resolved.expression = msg.expression;
    }
    else {
      resolved.expression = 0
    }

    if (msg.valence !== undefined) {
      resolved.valence = msg.valence;
    }
    else {
      resolved.valence = 0.0
    }

    if (msg.arousal !== undefined) {
      resolved.arousal = msg.arousal;
    }
    else {
      resolved.arousal = 0.0
    }

    return resolved;
    }
};

// Constants for message
Expression.Constants = {
  NEUTRAL: 0,
  HAPPY: 1,
  SAD: 2,
  ANGER: 3,
  SURPRISE: 4,
  DISGUST: 5,
  FEAR: 6,
}

module.exports = Expression;
