// Auto-generated. Do not edit!

// (in-package hri_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class IdsMatch {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.face_id = null;
      this.body_id = null;
      this.voice_id = null;
      this.person_id = null;
      this.confidence = null;
    }
    else {
      if (initObj.hasOwnProperty('face_id')) {
        this.face_id = initObj.face_id
      }
      else {
        this.face_id = '';
      }
      if (initObj.hasOwnProperty('body_id')) {
        this.body_id = initObj.body_id
      }
      else {
        this.body_id = '';
      }
      if (initObj.hasOwnProperty('voice_id')) {
        this.voice_id = initObj.voice_id
      }
      else {
        this.voice_id = '';
      }
      if (initObj.hasOwnProperty('person_id')) {
        this.person_id = initObj.person_id
      }
      else {
        this.person_id = '';
      }
      if (initObj.hasOwnProperty('confidence')) {
        this.confidence = initObj.confidence
      }
      else {
        this.confidence = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type IdsMatch
    // Serialize message field [face_id]
    bufferOffset = _serializer.string(obj.face_id, buffer, bufferOffset);
    // Serialize message field [body_id]
    bufferOffset = _serializer.string(obj.body_id, buffer, bufferOffset);
    // Serialize message field [voice_id]
    bufferOffset = _serializer.string(obj.voice_id, buffer, bufferOffset);
    // Serialize message field [person_id]
    bufferOffset = _serializer.string(obj.person_id, buffer, bufferOffset);
    // Serialize message field [confidence]
    bufferOffset = _serializer.float32(obj.confidence, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type IdsMatch
    let len;
    let data = new IdsMatch(null);
    // Deserialize message field [face_id]
    data.face_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [body_id]
    data.body_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [voice_id]
    data.voice_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [person_id]
    data.person_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [confidence]
    data.confidence = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.face_id.length;
    length += object.body_id.length;
    length += object.voice_id.length;
    length += object.person_id.length;
    return length + 20;
  }

  static datatype() {
    // Returns string type for a message object
    return 'hri_msgs/IdsMatch';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b89180f024652cbde26438c50a19cae6';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # This message encodes possible matches between transient IDs (face, body,
    # voice) and permanent IDs (person), with their corresponding confidence level.
    # Such messages should be published on the /humans/id_association topic.
    #
    # For instance, a face recognition module might publish the following message
    # to indicate that face 'a3eb4' has been recognised with 63% confidence as
    # person 'b31ad':
    #
    # {face_id: 'a3eb4', 
    #  body_id: '', 
    #  voice_id: '', 
    #  person_id: 'b31ad'
    #  confidence: 0.63, 
    # }
    #
    # Another example: a module that detect both faces and skeleton might publish
    # a 100% confidence match between the two:
    #
    # {face_id: 'ff424', 
    #  body_id: '850d1', 
    #  voice_id: '', 
    #  person_id: ''
    #  confidence: 1.0, 
    # }
    
    string face_id
    string body_id
    string voice_id
    string person_id
    
    float32 confidence
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new IdsMatch(null);
    if (msg.face_id !== undefined) {
      resolved.face_id = msg.face_id;
    }
    else {
      resolved.face_id = ''
    }

    if (msg.body_id !== undefined) {
      resolved.body_id = msg.body_id;
    }
    else {
      resolved.body_id = ''
    }

    if (msg.voice_id !== undefined) {
      resolved.voice_id = msg.voice_id;
    }
    else {
      resolved.voice_id = ''
    }

    if (msg.person_id !== undefined) {
      resolved.person_id = msg.person_id;
    }
    else {
      resolved.person_id = ''
    }

    if (msg.confidence !== undefined) {
      resolved.confidence = msg.confidence;
    }
    else {
      resolved.confidence = 0.0
    }

    return resolved;
    }
};

module.exports = IdsMatch;
